package kr.co.vividnext.sodalive.can.coupon

import com.querydsl.jpa.impl.JPAQueryFactory
import kr.co.vividnext.sodalive.can.coupon.QCanCoupon.canCoupon
import org.springframework.data.jpa.repository.JpaRepository

interface CanCouponRepository : JpaRepository<CanCoupon, Long>, CanCouponQueryRepository

interface CanCouponQueryRepository {
    fun getCouponTotalCount(): Int
    fun getCouponList(offset: Long, limit: Long): List<CanCoupon>
}

class CanCouponQueryRepositoryImpl(private val queryFactory: JPAQueryFactory) : CanCouponQueryRepository {
    override fun getCouponTotalCount(): Int {
        return queryFactory
            .select(canCoupon.id)
            .from(canCoupon)
            .fetch()
            .size
    }

    override fun getCouponList(offset: Long, limit: Long): List<CanCoupon> {
        return queryFactory
            .selectFrom(canCoupon)
            .orderBy(canCoupon.id.desc())
            .offset(offset)
            .limit(limit)
            .fetch()
    }
}
